| Home | Libraries | People | FAQ | More

##### static_url::set_user

Set the user.

###### Synopsis

    static_url&
    set_user(
        core::string_view s);

###### Description

This function sets the user part of the userinfo to the string. Any special or reserved characters in the string are automatically percent-encoded.

###### Example

    assert( url().set_user( "john doe" ).encoded_userinfo() == "john%20doe" );

###### Postconditions

    this->has_authority() == true && this->has_userinfo() == true

###### Complexity

Linear in `this->size() + s.size()`.

###### Exception Safety

Strong guarantee. Calls to allocate may throw.

###### Parameters

Name | Description
--- | ---
`s` | The string to set.

###### BNF

    userinfo      = [ [ user ] [ ':' password ] ]

    user          = *( unreserved / pct-encoded / sub-delims )
    password      = *( unreserved / pct-encoded / sub-delims / ":" )

###### Specification

- 3.2.1. User Information (rfc3986)

###### See Also

`remove_password`, `set_encoded_password`, `set_encoded_user`, /root/project/libs/url/include/boost/url/static_url.hpp